package com.lantone.qc.kernel.catalogue.firstpagerecord;

import com.lantone.qc.kernel.catalogue.QCCatalogue;
import com.lantone.qc.pub.Content;
import com.lantone.qc.pub.model.InputInfo;
import com.lantone.qc.pub.model.OutputInfo;
import com.lantone.qc.pub.util.StringUtil;
import org.springframework.stereotype.Component;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * @ClassName : FIRP0209
 * @Description : 工作单位及地址没有填写
 * @Author : 楼辉荣
 * @Date: 2020-03-06 17:28ss
 */
@Component
public class FIRP0209 extends QCCatalogue {

    private List<String> containList = Arrays.asList("农民", "家务", "自由职业者", "个体经营者", "无业人员", "儿童");

    public void start(InputInfo inputInfo, OutputInfo outputInfo) {
        status.set("0");
        if (inputInfo.getFirstPageRecordDoc() != null && inputInfo.getFirstPageRecordDoc().getStructureMap() != null) {
            Map<String, String> firstpageStructureMap = inputInfo.getFirstPageRecordDoc().getStructureMap();
            String dischargeTime = firstpageStructureMap.get(Content.work_unit);
            String job = firstpageStructureMap.get(Content.job);
            if (StringUtil.isBlank(job)) {
                return;
            }
            for (String str : containList) {
                if (str.contains(job)) {
                    return;
                }
            }
            if (StringUtil.isBlank(dischargeTime) || "—".equals(dischargeTime)) {
                status.set("-1");
            }
        }
    }
}