package com.lantone.qc.kernel.catalogue.firstpagerecord;

import com.lantone.qc.kernel.catalogue.QCCatalogue;
import com.lantone.qc.pub.Content;
import com.lantone.qc.pub.model.InputInfo;
import com.lantone.qc.pub.model.OutputInfo;
import com.lantone.qc.pub.util.StringUtil;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 * @ClassName : FIRP0211
 * @Description : 单位电话未填写
 * @Author : 楼辉荣
 * @Date: 2020-03-06 17:28ss
 */
@Component
public class FIRP0211 extends QCCatalogue {
    public void start(InputInfo inputInfo, OutputInfo outputInfo) {
        status.set("0");
        if (inputInfo.getFirstPageRecordDoc() != null && inputInfo.getFirstPageRecordDoc().getStructureMap() != null) {
            Map<String, String> firstpageStructureMap = inputInfo.getFirstPageRecordDoc().getStructureMap();
            String dischargeTime = firstpageStructureMap.get(Content.work_unit_phone);
            //工作单位 (无工作单位者无需填写单位邮编、电话及地址)
            String workUnit = firstpageStructureMap.get(Content.work_unit);
            if (StringUtil.isBlank(workUnit) || "—".equals(workUnit)) {
                return;
            }
            if (StringUtil.isBlank(dischargeTime) || "—".equals(dischargeTime)) {
                status.set("-1");
            }

        }
    }
}