package com.lantone.qc.pub.model.doc;

import lombok.Getter;
import lombok.Setter;

import java.util.Date;

/**
 * @ClassName: AnesthesiaRecordDoc
 * @Description: 手麻记录文档
 * @Author songxl
 * @Date 2021/3/19
 * @Version 1.0
 */
@Getter
@Setter
public class AnesthesiaRecordDoc extends ModelDoc{
    private Long id;
    private Long hospitalId;                        //医院ID
    private String behospitalCode;                  //病历号
    private Date anesStartTime;                     //开始时间
    private String diagBeforeOperation;             //术前诊断
    private String diagAfterOperation;              //术后诊断
    private String operationName;                   //手术名称
    private String anesthesiaDoctor;                //麻醉医师
    private String bleedingAmount;                  //出血量
    private Long did;                        //主刀医师ID
    private String doctorName;                      //主刀医师
    private String anesthesiaMethod;                //麻醉方式
    private Date anesEndTime;                       //手术结束时间
    private Date inAnesStartTime;                   //入手术时间（进入手术室时间，早于手术时间，用于术前准备）
    private String is_deleted;                      //是否删除
}
