package com.lantone.qc.trans.beilun;

import com.lantone.qc.pub.model.doc.BeHospitalizedDoc;
import com.lantone.qc.pub.model.doc.VTEGradeDoc;
import com.lantone.qc.pub.model.vo.MedrecVo;
import com.lantone.qc.pub.util.FastJsonUtils;
import com.lantone.qc.trans.ModelDocTrans;
import com.lantone.qc.trans.beilun.util.BeiLunBeHospitalizedHtmlAnalysis;
import com.lantone.qc.trans.beilun.util.BeiLunHtmlAnalysis;
import com.lantone.qc.trans.beilun.util.BeiLunVTEGradeHtmlAnalysis;
import com.lantone.qc.trans.comsis.ModelDocGenerate;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections.MapUtils;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: BeiLunVTEGradeDocTrans
 * @Description: VTE评分
 * @Author songxl
 * @Date 2021/3/9
 * @Version 1.0
 */
@Slf4j
public class BeiLunVTEGradeDocTrans extends ModelDocTrans {
    @Override
    public VTEGradeDoc extract(MedrecVo medrecVo) {
        VTEGradeDoc vteGradeDoc = null;
        try {
            Map<String, Object> contentMap = ((List<Map>) medrecVo.getContent().get("content")).get(0);
            String content = contentMap.get("xmlText").toString();
            Map<String, String> structureMap = null;
            if (contentMap.get("isParsed") != null && "1".equals(contentMap.get("isParsed").toString())) {
                structureMap = (Map) FastJsonUtils.getJsonToMap(content);
            } else {
                String recTitle = contentMap.get("recTitle").toString();
                String recTypeId = contentMap.get("recTypeId").toString();
                BeiLunVTEGradeHtmlAnalysis vteGradeHtmlAnalysis = new BeiLunVTEGradeHtmlAnalysis();
                Map<String, String> sourceMap = vteGradeHtmlAnalysis.analysis(content, recTitle, recTypeId);
                if (MapUtils.isNotEmpty(sourceMap)) {
                    structureMap.putAll(sourceMap);
                }
            }
            if (MapUtils.isNotEmpty(structureMap)) {
                              ModelDocGenerate.beHospitalizedDocGen(structureMap);
                vteGradeDoc = ModelDocGenerate.vteGradeDocGen(structureMap);
                vteGradeDoc.setPageData((Map) structureMap);
            }
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
        return vteGradeDoc;
    }
}
