package com.lantone.qc.trans.ningbozhenhai.util;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.lantone.qc.trans.comsis.CommonAnalysisUtil;
import lombok.extern.slf4j.Slf4j;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: rengb
 * @time: 2020/9/17 14:27
 */
@Slf4j
public class DeathCaseDiscussHtmlAnalysis implements HtmlAnalysis {

    private String modeId = "3";

    @Override
    public Map<String, String> analysis(String... args) {
        Map<String, String> map = Maps.newLinkedHashMap();
        try {
            String html = args[0];
            String recTypeId = args[2];
            Document doc = Jsoup.parse(html);
            Element bigDivElement = doc.selectFirst("body").child(0);
            HtmlAnalysisUtil.tableStyle1InsertMap(doc.getElementById("table4_6"), map);
            String text = HtmlAnalysisUtil.blockDivToStr(bigDivElement, false).replace("病情变化、诊治、抢救情况", "");

            int index1 = text.lastIndexOf("记录者签名");
            int index2 = text.lastIndexOf("主持人签名");
            if (index1 != -1 && index2 != -1) {
                text = text.substring(0, index1)
                        + text.substring(index1, index2).replace("签字时间", "记录者签字时间：").replace("年月日时分", "")
                        + text.substring(index2).replace("签字时间", "主持人签字时间：").replace("年月日时分", "");
            }

            List<String> titles = Lists.newArrayList("姓名", "性别", "年龄 ", "地址 ", "入院时间", "死亡时间", "讨论时间", "讨论地点",
                    "讨论主持人", "参加人员", "讨论内容（包括病史摘要、治疗抢救过程、讨论目的、讨论意见及结论）", "病史摘要（经管医师汇报病史）", "讨论目的",
                    "讨论意见", "主持人小结", "死亡原因", "死亡诊断", "记录者签名", "记录者签字时间", "主持人签名", "主持人签字时间");
            titles = CommonAnalysisUtil.sortTitles(titles, text);
            CommonAnalysisUtil.cutByTitlesNoColon(text, titles, 0, map);
            HtmlAnalysisUtil.mapValueRemoveStartColon(map);
            HtmlAnalysisUtil.insertModuleId(modeId, recTypeId, map);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
        return map;
    }

}