package com.lantone.qc.trans.ningbozhenhai.util;

import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;

import java.util.Map;

/**
 * @ClassName: VTEGradeHtmlAnalysis
 * @Description: VTE评分HTML解析
 * @Author songxl
 * @Date 2021/3/9
 * @Version 1.0
 */
@Slf4j
public class VTEGradeHtmlAnalysis implements HtmlAnalysis {
    private String modeId = "0";//模块id待定
    @Override
    public Map<String, String> analysis(String... args) {
        Map<String, String> map = Maps.newLinkedHashMap();
        try {
            String html = args[0];
            String recTitle = args[1];
            String recTypeId = args[2];

            Document doc = Jsoup.parse(html);
            //评估日期
            Element valuationName = doc.getElementById("table4").getElementsByTag("tr").get(2)
                    .getElementsByTag("span").get(0);
            Element valuationTime = doc.getElementById("table4").getElementsByTag("tr").get(2)
                    .getElementsByTag("span").get(1);
            map.put(valuationName.text().replaceAll("：",""),valuationTime.text());
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
        return map;
    }
}
