package com.lantone.qc.trans.ningbozhongyi;

import com.lantone.qc.pub.model.doc.ADLGradeDoc;
import com.lantone.qc.pub.model.vo.MedrecVo;
import com.lantone.qc.pub.util.FastJsonUtils;
import com.lantone.qc.trans.ModelDocTrans;
import com.lantone.qc.trans.comsis.ModelDocGenerate;
import com.lantone.qc.trans.ningbozhongyi.util.NingBoZhongYiADLGradeHtmlAnalysis;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections.MapUtils;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: NingBoZhongYiADLGradeDocTrans
 * @Description: ADL评分
 * @Author songxl
 * @Date 2021/3/9
 * @Version 1.0
 */
@Slf4j
public class NingBoZhongYiADLGradeDocTrans extends ModelDocTrans {
    @Override
    public ADLGradeDoc extract(MedrecVo medrecVo) {
        ADLGradeDoc adlGradeDoc = null;
        try {
            Map<String, Object> contentMap = ((List<Map>) medrecVo.getContent().get("content")).get(0);
            String content = contentMap.get("xmlText").toString();
            Map<String, String> structureMap = null;
            if (contentMap.get("isParsed") != null && "1".equals(contentMap.get("isParsed").toString())) {
                structureMap = (Map) FastJsonUtils.getJsonToMap(content);
            } else {
                String recTitle = contentMap.get("recTitle").toString();
                String recTypeId = contentMap.get("recTypeId").toString();
                NingBoZhongYiADLGradeHtmlAnalysis adlGradeHtmlAnalysis = new NingBoZhongYiADLGradeHtmlAnalysis();
                Map<String, String> sourceMap = adlGradeHtmlAnalysis.analysis(content, recTitle, recTypeId);
                if (MapUtils.isNotEmpty(sourceMap)) {
                    structureMap.putAll(sourceMap);
                }
            }
            if (MapUtils.isNotEmpty(structureMap)) {
                              ModelDocGenerate.beHospitalizedDocGen(structureMap);
                adlGradeDoc = ModelDocGenerate.adlGradeDocGen(structureMap);
                adlGradeDoc.setPageData((Map) structureMap);
            }
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
        return adlGradeDoc;
    }
}
