package com.lantone.qc.trans.ningbozhongyi.util;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.lantone.qc.pub.util.StringUtil;
import com.lantone.qc.trans.comsis.CommonAnalysisUtil;
import lombok.extern.slf4j.Slf4j;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: HUJING
 * @time: 2020/9/9 11:24
 */
@Slf4j
public class NingBoZhongYiFirstCourseRecordHtmlAnalysis implements NingBoZhongYiHtmlAnalysis {

    private String modeId = "2";

    @Override
    public Map<String, String> analysis(String... args) {
        Map<String, String> structureMap = Maps.newLinkedHashMap();
        try {
            List<String> titles = Lists.newArrayList("病例特点", "拟诊讨论",  "中医辨病辨证依据", "中医鉴别诊断","西医鉴别诊断","鉴别诊断","西医诊断依据","诊断依据", "初步诊断",  "病情评估", "诊疗计划");
            String html = args[0];
            String recTitle = args[1];
            Document doc = Jsoup.parse(html);
            String htmlContent = NingBoZhongYiHtmlAnalysisUtil.blockDivToStr(doc.selectFirst("body").child(0), true);
            if (StringUtil.isNotBlank(htmlContent)) {
                String[] lines = htmlContent.split("\n\n");
                if (StringUtil.isNotBlank(lines[0])) {
                    String date = CommonAnalysisUtil.extractDate(lines[0]);
                    if (StringUtil.isNotBlank(date)) {
                        structureMap.put("时间", date);
                        lines[0] = lines[0].replace(date, "");
                    }
                }
                titles = CommonAnalysisUtil.sortTitles(titles, htmlContent);
                CommonAnalysisUtil.cutByTitles(htmlContent, titles, 0, structureMap);
                if (structureMap.get("中医辨病辨证依据")!=null&&structureMap.get("西医诊断依据")!=null){
                    structureMap.put("诊断依据", "中医辨病辨证依据：" + structureMap.get("中医辨病辨证依据") + "西医诊断依据：" + structureMap.get("西医诊断依据"));
                }
                if (structureMap.get("中医鉴别诊断")!=null&&structureMap.get("西医鉴别诊断")!=null){
                    structureMap.put("鉴别诊断", "中医鉴别诊断：" + structureMap.get("中医鉴别诊断") + "西医鉴别诊断：" + structureMap.get("西医鉴别诊断"));
                }
            }

            NingBoZhongYiHtmlAnalysisUtil.insertModuleId(modeId, recTitle, structureMap);
            //        CommonAnalysisUtil.extractDateByTitle(structureMap, "时间");
            //        structureMap.forEach((k,v)-> System.out.println(k + "------" + v));
            //        structureMap.put("rec_title=", "107");

            structureMap.put("诊疗计划",structureMap.get("诊疗计划").replace("医生签名",""));
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
        return structureMap;
    }

}