package com.lantone.qc.trans.ningbozhongyi.util;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.lantone.qc.trans.comsis.CommonAnalysisUtil;
import lombok.extern.slf4j.Slf4j;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Element;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: rengb
 * @time: 2020/9/28 16:36
 */
@Slf4j
public class NingBoZhongYiOperationRecordHtmlAnalysis implements NingBoZhongYiHtmlAnalysis {

    private String modeId = "17";

    @Override
    public Map<String, String> analysis(String... args) {
        Map<String, String> map = Maps.newLinkedHashMap();
        try {
            String html = args[0];
            String recTitle = args[1];
            String recTypeId = args[2];
            Element bigDivElement = Jsoup.parse(html).selectFirst("body").child(0);
            analysisGeneral(bigDivElement, map);
            NingBoZhongYiHtmlAnalysisUtil.mapValueRemoveStartColon(map);
            //String operatingCrew = null;

            if (!map.containsKey("手术人员") && map.containsKey("手术者") && map.containsKey("助手（一、二）")) {
                map.put("手术人员", map.get("手术者") + " " + map.get("助手（一、二）"));
            }
            if (map.containsKey("术中诊断")) {
                map.put("手术中诊断", map.get("术中诊断"));
            }
            if (map.containsKey("麻醉者")) {
                map.put("麻醉人员", map.get("麻醉者"));
            }
            if (map.containsKey("手术经过（手术一般情况、术中发现；处理、标本处理、病切）")) {
                map.put("手术经过（包括病人体位，切口处理经过及病理标本肉眼所见）", map.get("手术经过（手术一般情况、术中发现；处理、标本处理、病切）"));
            }
            /*if (map.containsKey("手术人员")) {
                operatingCrew = map.get("手术人员");
            } else if (map.containsKey("手术者及助手名称")) {
                operatingCrew = map.get("手术者及助手名称");
            }
            if (StringUtil.isNotBlank(operatingCrew)) {
                CommonAnalysisUtil.cutByTitles(operatingCrew, Lists.newArrayList("主刀", "一助", "二助", "助手", "洗手护士"), 0, map);
            }
            if (map.containsKey("主刀")) {
                map.put("主刀", map.get("主刀").replaceAll("[^\u4E00-\u9FA5]", ""));
            }*/
            /*if (map.containsKey("麻醉者")) {
                String anesthetist = map.get("麻醉者").replace("麻醉医生：", "");
                map.put("麻醉医师", anesthetist);
                if (anesthetist.contains("1.")) {
                    int index = anesthetist.indexOf("1.");
                    map.put("麻醉医师", anesthetist.substring(0, index));
                    map.put("手术经过", anesthetist.substring(index));
                }
            }*/
            /*if (map.containsKey("手术日期")) {
                String operatorDateStr = map.get("手术日期");
                if (operatorDateStr.contains("--")) {
                    String[] operatorDate = operatorDateStr.split("--");
                    map.put("手术开始时间", operatorDate[0]);
                    map.put("手术结束时间", operatorDate[1]);
                }
            }*/
            CommonAnalysisUtil.makeEmpty(map, "医生签名");
            NingBoZhongYiHtmlAnalysisUtil.insertModuleId(modeId, recTypeId, map);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
        return map;
    }

    private void analysisGeneral(Element bigDivElement, Map<String, String> map) {
        /*if (bigDivElement.selectFirst("hr") != null) {
            bigDivElement.selectFirst("hr").previousElementSiblings().remove();
        }*/
        String text = NingBoZhongYiHtmlAnalysisUtil.blockDivToStr(bigDivElement, true);
        text = text.replaceAll("第1页", "");
        List<String> titles = Lists.newArrayList(
                "姓名", "性别", "年龄", "婚姻", "出生日期", "出生年月", "科别", "科室", "病区", "床号", "床位", "住院号",
                "手术时间", "手术日期", "手术前诊断", "术前诊断", "手术中诊断", "术中诊断", "手术指征", "手术人员", "手 术 者", "助手（一、二）", "麻醉方式", "麻醉人员", "手术经过（包括病人体位，切口处理经过及病理标本肉眼所见）", "手术经过（手术一般情况、术中发现；处理、标本处理、病切）", "麻 醉 者", "洗手护士", "本次手术是否属于非计划再次手术", "接生者",
                "术前胎心", "手术名称", "术后诊断", "手术者及助手名称", "术中取病理标本", "麻醉方法", "诊断手术/操作简要经过（包括术中有无并发症及具体描述和处理）", "手术经过",
                "医生签名", "记录时间", "时间", "手术/操作医生", "记录者", "术中输血", "术前宫颈准备日期", "药物名称及用法", "导管或其他", "插入深度",
                "阴道填塞纱布条", "准备者", "取出日期", "手术方法", "术中特殊情况", "病理检查", "其他", "记录者", "手术者", "医师签字", "日期",
                "检查子宫位置"
        );
        titles = CommonAnalysisUtil.sortTitles(titles, text);
        CommonAnalysisUtil.cutByTitlesNoColon(text, titles, 0, map);
    }

}