package com.lantone.qc.trans.shengzhouyy;

import com.google.common.collect.Lists;
import com.lantone.qc.dbanaly.facade.shengzhouzz.ShengzhouyyXmlUtil;
import com.lantone.qc.dbanaly.util.ModuleMappingUtil;
import com.lantone.qc.pub.model.doc.DeathCaseDiscussDoc;
import com.lantone.qc.pub.model.vo.MedrecVo;
import com.lantone.qc.pub.util.FastJsonUtils;
import com.lantone.qc.pub.util.MapUtil;
import com.lantone.qc.trans.ModelDocTrans;
import com.lantone.qc.trans.comsis.OrdinaryAssistant;
import org.apache.commons.lang3.StringUtils;

import java.util.List;
import java.util.Map;

/**
 * @Description: 死亡病例讨论记录文档生成
 */
public class DeathCaseDiscussDocTrans extends ModelDocTrans {
    private String modeId = "3";

    @Override
    public DeathCaseDiscussDoc extract(MedrecVo medrecVo) {
        Map<String, Object> contentMap = ((List<Map>) medrecVo.getContent().get("content")).get(0);
        String content = contentMap.get("xmlText").toString();
        Map<String, String> structureMap = null;
        if (contentMap.get("isParsed") != null && "1".equals(contentMap.get("isParsed").toString())) {
            structureMap = (Map) FastJsonUtils.getJsonToMap(content);
        } else {
            Map<String, String> sourceMap = ShengzhouyyXmlUtil.xmlToMap(content);
            sourceMap.put("mode_id", ModuleMappingUtil.getDeptModuleId(modeId));
            sourceMap.put("mode_id=" + contentMap.get("modeId").toString(), "");
            sourceMap.put("rec_title=" + contentMap.get("recTitle").toString(), "");
            String moderator_summary_opinions = sourceMap.get("主持人总结意见");
            if (StringUtils.isNotBlank(moderator_summary_opinions)){
                String[] split = moderator_summary_opinions.split("死亡原因：");
                sourceMap.put("主持人小结",split[0]);
                sourceMap.put("死亡诊断",split[1]);
            }
            structureMap = OrdinaryAssistant.mapKeyContrast(sourceMap, keyContrasts, modeId);
        }

        MapUtil.keyAssig(structureMap, "参加讨论人员", "参加人员及职称医生", "参加人员及职称");
        DeathCaseDiscussDoc deathCaseDiscussDoc = new DeathCaseDiscussDoc();
        deathCaseDiscussDoc.setStructureMap(structureMap);
        deathCaseDiscussDoc.setPageData((Map) structureMap);

        return deathCaseDiscussDoc;
    }

    private List<String> keyContrasts = Lists.newArrayList(
            "病程时间=讨论时间",
            "主持人姓名=主持人",
            "参加讨论人员名单=参加人员",
            "讨论结论=讨论内容",
            "记录人签名=记录医生"
    );
}
