package com.lantone.qc.trans.wenfuyi.util;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.lantone.qc.trans.comsis.CommonAnalysisUtil;
import lombok.extern.slf4j.Slf4j;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Element;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: rengb
 * @time: 2020/9/28 17:56
 */
@Slf4j
public class ClinicalBloodHtmlAnalysis implements WenFuYiHtmlAnalysis {


    private String modeId = "10";

    @Override
    public Map<String, String> analysis(String... args) {
        Map<String, String> map = Maps.newLinkedHashMap();
        try {
            String html = args[0];
            String recTitle = args[1];
            String recTypeId = args[2];
            String content = Jsoup.parse(html).selectFirst("body").children().text();
            analysisGeneral(recTitle, content, map);
            WenFuYiHtmlAnalysisUtil.insertModuleId(modeId, recTypeId, map);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
        return map;
    }

    private void analysisGeneral(String recTitle, String content, Map<String, String> map) {
        CommonAnalysisUtil.extractWardInfo(recTitle, content, map);
        String bqjlText = "病情记录：" + map.get("病情记录");
        map.remove("病情记录");
        List<String> titles = Lists.newArrayList(
                "病情记录", "输血制品原因", "输血制品日期", "输血制品种类及量", "输血制品反应", "输血制品效果评价"
        );
        titles = CommonAnalysisUtil.sortTitles(titles, bqjlText);
        CommonAnalysisUtil.cutByTitles(bqjlText, titles, 0, map);
    }

}