package com.lantone.qc.trans.wenfuyi.util;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.lantone.qc.pub.util.StringUtil;
import com.lantone.qc.trans.comsis.CommonAnalysisUtil;
import lombok.extern.slf4j.Slf4j;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: HUJING
 * @time: 2020/9/9 11:24
 */
@Slf4j
public class FirstCourseRecordHtmlAnalysis implements WenFuYiHtmlAnalysis {

    private String modeId = "2";

    @Override
    public Map<String, String> analysis(String... args) {
        Map<String, String> structureMap = Maps.newLinkedHashMap();
        try {
            List<String> titles = Lists.newArrayList("一.病例特点", "二.拟诊讨论（诊断依据及鉴别诊断）", "三.初步诊断", "四.诊疗计划");
            String html = args[0];
            String recTitle = args[1];
            Document doc = Jsoup.parse(html);
            String htmlContent = WenFuYiHtmlAnalysisUtil.blockDivToStr(doc.selectFirst("body"), true);
            if (StringUtil.isNotBlank(htmlContent)) {
                String[] lines = htmlContent.split("\n\n");
                titles = CommonAnalysisUtil.sortTitlesNoColon(titles, htmlContent);
                CommonAnalysisUtil.cutByTitlesNoColon(htmlContent, titles, 0, structureMap);
            }

            WenFuYiHtmlAnalysisUtil.insertModuleId(modeId, recTitle, structureMap);
            //        CommonAnalysisUtil.extractDateByTitle(structureMap, "时间");
            //        structureMap.forEach((k,v)-> System.out.println(k + "------" + v));
            //        structureMap.put("rec_title=", "107");

        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
        return structureMap;
    }

}