package com.lantone.qc.trans.wenfuyi.util;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.lantone.qc.trans.comsis.CommonAnalysisUtil;
import lombok.extern.slf4j.Slf4j;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Element;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: rengb
 * @time: 2020/9/28 20:16
 */
@Slf4j
public class StagesSummaryHtmlAnalysis implements WenFuYiHtmlAnalysis {

    private String modeId = "28";

    @Override
    public Map<String, String> analysis(String... args) {
        Map<String, String> map = Maps.newLinkedHashMap();
        try {
            String html = args[0];
            String recTitle = args[1];
            String recTypeId = args[2];
            Element bigDivElement = Jsoup.parse(html).selectFirst("body");
            analysisGeneral(recTitle, bigDivElement, map);
            WenFuYiHtmlAnalysisUtil.insertModuleId(modeId, recTypeId, map);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
        return map;
    }

    private void analysisGeneral(String recTitle, Element bigDivElement, Map<String, String> map) {
        String text = WenFuYiHtmlAnalysisUtil.blockDivToStr(bigDivElement, true);
        CommonAnalysisUtil.extractWardInfo(recTitle, text, map);
        String bqjlText = "病情记录：" + map.get("病情记录");
        map.remove("病情记录");
        List<String> titles = Lists.newArrayList(
                "病情记录", "入院情况", "入院诊断", "诊疗经过", "目前情况", "目前诊断", "诊疗计划", "治疗组组长"
        );
        titles = CommonAnalysisUtil.sortTitles(titles, bqjlText);
        CommonAnalysisUtil.cutByTitles(bqjlText, titles, 0, map);
    }

}